addHook("AbilitySpecial", function(player)
	if player.mo.skin == "s3sonic"
		if not (player.mo.hyperform) then
	       player.mo.hyperform = 0
	    end
		
		if (player.powers[pw_super])
		and not player.powers[pw_invulnerability] 
		and not player.powers[pw_flashing]
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS4)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS5)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS6)
		and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT) 
		and player.mo.hyperform == 0
		and (player.rings >= 100)
		and (player.powers[pw_shield] == SH_NONE or player.powers[pw_shield] == SH_FIREFLOWER)
		    P_DoSuperTransformation(player, true)
			S_StopSoundByID(player.mo, sfx_supert)
			S_StartSound(player.mo, sfx_s3k9f)
	        player.mo.hyperform = 1
			player.hypertrans = true
	    end
    end  
end)



addHook("PlayerThink", function(player)
	if (player.mo.skin == "s3sonic")
	    if (player.speed >= FixedMul(player.runspeed, player.mo.scale))
	    and player.mo.hyperform
           local hypertrail = P_SpawnGhostMobj(player.mo)
	       hypertrail.color = (SKINCOLOR_HYPER1 + abs(((player.powers[pw_super] >> 2) % 9) - 6))
           hypertrail.fuse = 4
	       hypertrail.rollangle = player.mo.rollangle
		end   
	end
end)


addHook("AbilitySpecial", function(player)
	if (player.mo.skin == "s3sonic")
	and player.mo.hyperform == 1
	and not (player.pflags & PF_THOKKED)
		P_NukeEnemies(player.mo, player.mo, 1000*FRACUNIT)
		S_StartSound(player.mo, sfx_s3kb6)
		P_FlashPal(player, PAL_WHITE, 5)
		P_Thrust(player.mo, player.mo.angle, 25*FRACUNIT)
		player.pflags = $|PF_THOKKED 
	end
end)


// Others \\


addHook("PlayerThink", function(player)
    if player.mo.hyperform
		player.powers[pw_underwater] = 100*TICRATE
		player.powers[pw_spacetime] = 100*TICRATE
	 end
end)


addHook('PlayerThink', do
	for player in players.iterate
	    if player.mo and player.mo.valid
			if player.powers[pw_super] == 0
			 player.mo.hyperform = 0
			 P_RestoreMusic(player)
		     player.mo.color = player.skincolor
		     player.normalspeed = skins[player.mo.skin].normalspeed
		 end
	 end 
end
end)


addHook("PlayerThink", function(player)
	if leveltime % 4 == 0 then
		if player.mo.hyperform
		and player.mo.skin == "s3sonic"
			local strikesparkle = P_SpawnMobj(player.mo.x+(P_RandomRange(16,-16)*FRACUNIT),player.mo.y+(P_RandomRange(16,-16)*FRACUNIT),player.mo.z+(player.mo.height/2)+(P_RandomRange(8,-8)*FRACUNIT),MT_SUPERSPARK)
			strikesparkle.color = SKINCOLOR_GREY
			strikesparkle.colorized = true
			strikesparkle.scale = player.mo.scale * 3 / 2
			strikesparkle.momx = P_RandomRange(5,-5)*FRACUNIT
			strikesparkle.momy = P_RandomRange(5,-5)*FRACUNIT
			strikesparkle.momz = P_RandomRange(5,-5)*FRACUNIT
	     end
	 end
end)


addHook("PlayerThink", function(player)
    if player.mo.skin == "s3sonic"
	    if player.hypertrans
		and player.mo.hyperform == 1
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
			player.mo.color = (SKINCOLOR_HYPER1 + abs(((player.powers[pw_super] >> 2) % 9) - 6))
		end
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.hyperform == 1) then
	    if (skins[player.mo.skin])
		  and not (player.mo.skin == "s3sonic") then
			player.mo.hyperform = 0
		end
	end
end)


// Colors \\


// Hyper colors. 


// Red Starts

freeslot("SKINCOLOR_HYPER1")
skincolors[SKINCOLOR_HYPER1] = {
	name = "Hyper 1",
	ramp = {0,0,0,0,0,0,0,0,209,209,210,210,32,32,33,33},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Blue

freeslot("SKINCOLOR_HYPER2")
skincolors[SKINCOLOR_HYPER2] = {
	name = "Hyper 2",
	ramp = {0,0,0,0,0,0,0,0,129,129,130,130,131,131,132,132},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Green

freeslot("SKINCOLOR_HYPER3")
skincolors[SKINCOLOR_HYPER3] = {
	name = "Hyper 3",
	ramp = {0,0,0,0,0,0,0,0,98,98,99,99,100,100,101,101},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Yellow

freeslot("SKINCOLOR_HYPER4")
skincolors[SKINCOLOR_HYPER4] = {
	name = "Hyper 4",
	ramp = {0,0,0,0,0,0,0,0,82,82,83,83,72,72,74,74},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// White

freeslot("SKINCOLOR_HYPER5")
skincolors[SKINCOLOR_HYPER5] = {
	name = "Hyper 5",
	ramp = {0,0,0,0,0,0,0,0,1,1,2,2,3,3,4,4},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Violet

freeslot("SKINCOLOR_HYPER6")
skincolors[SKINCOLOR_HYPER6] = {
	name = "Hyper 6",
	ramp = {0,0,0,0,0,0,0,0,160,160,161,161,162,162,163,163},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Red ending

freeslot("SKINCOLOR_HYPER7")
skincolors[SKINCOLOR_HYPER7] = {
	name = "Hyper 7",
	ramp = {0,0,0,0,0,0,0,0,200,200,201,201,202,202,203,203},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}